'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Created by varun on 19/12/17.
 * TODO : 1. need to take in different table configurations, 2. need a preprocessor for data before drawing table
 */

var AdharaTableView = function (_AdharaView) {
    _inherits(AdharaTableView, _AdharaView);

    /***
     * @param url The api URL
     * @config the configurations required for the table
     *          the config object comprises of the following:
     *          1. columns - array - the colummns for the table. (Only these fields are fetched by the url)
     *          2. url - string - the apiurl
     *          2. title - string - the title for the table
     *          3. add_new - boolean - defaulted to false, "add new" button will be present if set as true
     *          4. nav - boolean - defaulted to false, will display navigations if set as true
     */

    function AdharaTableView(url, config) {
        _classCallCheck(this, AdharaTableView);

        var _this = _possibleConstructorReturn(this, (AdharaTableView.__proto__ || Object.getPrototypeOf(AdharaTableView)).call(this, 'table'));

        _this.url = url;
        _this.config = config;
        AdharaTableView.validateConf(_this.config);
        return _this;
    }

    _createClass(AdharaTableView, [{
        key: 'render',
        value: function render(containerSelector) {
            this.initFetch(containerSelector);
        }
    }, {
        key: 'initFetch',
        value: function initFetch(containerSelector) {
            jQuery.ajax({
                url: this.config.url,
                method: 'GET',
                success: function success(data) {
                    this.data = data;
                    this.drawTable(containerSelector);
                },
                error: function error() {}
            });
        }
    }, {
        key: 'drawTable',
        value: function drawTable(containerSelector) {
            this.container = document.querySelector(containerSelector);
            this.container.innerHTML = Handlebars.templates[this.template]({ 'config': this.config, 'data': this.data });
            this.postProcess(this.container);
        }
    }], [{
        key: 'validateConf',
        value: function validateConf(conf) {
            var errors = [];
            if (!conf.url) {
                errors.push("No URL in config.");
            }
            if (!conf.columns) {
                errors.push("No COLUMNS in config.");
            }
            if (!conf.title) {
                errors.push("No TITLE in config.");
            }
            if (conf.add_new == undefined) {
                conf.add_new = true;
            }
            if (conf.nav == undefined) {
                conf.nav = false;
            }

            if (!errors.length == 0) {
                throw new Error(errors.join(','));
            }
        }
    }]);

    return AdharaTableView;
}(AdharaView);
//# sourceMappingURL=TableView.js.map