'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Created by varun on 21/12/17.
 */

var AdharaPopup = function () {

    /**
     * @param title The title of the popup
     * @param message The message for the popup
     * @param confirmOptions The confirm options,
     *        1. isConfirm - if the popup is a confirm dialog
     *        2. text - the text for the confirm button
     *        3. callback - the callback on confirm
     * */

    function AdharaPopup(title, message, confirmOptions) {
        _classCallCheck(this, AdharaPopup);

        this.message = message;
        this.title = title;
        this.confirmOptions = AdharaPopup.validateConfirm(confirmOptions);
    }

    /**
     * @description method to show the popup
     * */


    _createClass(AdharaPopup, [{
        key: 'show',
        value: function show() {
            var template = document.querySelector('#adharaDialog');

            if (!template) {
                template = Handlebars.templates['popup']({ 'message': this.message, 'title': this.title, 'confirmOptions': this.confirmOptions });

                var wrapper = document.createElement('div');
                wrapper.innerHTML = template;

                document.querySelector('body').appendChild(wrapper);

                template = wrapper.querySelector('#adharaDialog');
            } else {
                template.querySelector('.modal-title').textContent = this.title;
                template.querySelector('.modal-msg').innerHTML = this.message;
            }

            if (this.confirmOptions.isConfirm) {
                var confirmBtn = template.querySelector('.confirm-btn');
                if (!confirmBtn) {
                    //TODO handle in a better fashion
                    template.querySelector('.modal-footer').appendChild(jQuery('<button type="button" class="btn btn-secondary confirm-btn" data-dismiss="modal">' + this.confirmOptions.text + '</button>').get(0));
                }
                confirmBtn.onclick = this.confirmOptions.callback;
            } else if (template.querySelector('.confirm-btn')) {
                template.querySelector('.confirm-btn').remove();
            }

            $('#adharaDialog').modal('show');
        }

        /**
         * @description method to hide the popup
         * */

    }, {
        key: 'hide',
        value: function hide() {
            $('#adharaDialog').modal('hide');
        }

        /**
         * @description method to rerender the popup with new message and title
         * */

    }, {
        key: 'reconfig',
        value: function reconfig(message, title, confirmOptions) {
            if (title) {
                this.title = title;
            }
            this.message = message;
            this.confirmOptions = AdharaPopup.validateConfirm(confirmOptions);
        }
    }], [{
        key: 'validateConfirm',
        value: function validateConfirm(confirmOptions) {
            var ret = confirmOptions;
            if (!ret) {
                ret = {
                    isConfirm: false
                };
            } else if (!ret.text) {
                ret.text = "Confirm ?";
            }
            return ret;
        }
    }]);

    return AdharaPopup;
}();
//# sourceMappingURL=DialogView.js.map