"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * @class
 * @classdesc a base class that is to be extended by all the view classes
 * */
var AdharaView = function () {
    function AdharaView() {
        _classCallCheck(this, AdharaView);

        Adhara.instances[this.constructor.name] = this;
        this.subViews = [];
    }

    _createClass(AdharaView, [{
        key: "render",
        value: function render(containerSelector) {
            this.container = document.querySelector(containerSelector);
            this.container.innerHTML = Handlebars.templates[this.template](this.data);
            this.format(this.container);
        }
    }, {
        key: "getContentContainer",
        value: function getContentContainer() {
            return this.DOMcontent.querySelector(this.contentSelector);
        }
    }, {
        key: "format",
        value: function format() {
            //Control the DOM elements after rendering
        }
    }, {
        key: "data",
        set: function set(data) {
            this.data = data;
        },
        get: function get() {
            return {};
        }
    }, {
        key: "template",
        get: function get() {
            if (AdharaRouter.getCurrentPageName()) {
                return AdharaRouter.getCurrentPageName().replace(/_/g, "-");
            } else {
                var className = this.constructor.name.toLowerCase();
                if (className.endsWith("view")) {
                    return className.slice(0, className.length - 4);
                } else {
                    return className;
                }
            }
        }
    }, {
        key: "contentSelector",
        get: function get() {
            throw new Error("Not implemented");
        }
    }, {
        key: "getSubViews",
        get: function get() {
            return this.subViews;
        }
    }, {
        key: "setSubViews",
        set: function set(subViews) {
            this.getSubViews.concat(subViews);
        }
    }, {
        key: "setSubView",
        set: function set(subView) {
            this.getSubViews.push(subView);
        }
    }]);

    return AdharaView;
}();
//# sourceMappingURL=View.js.map